<script>
    import { onDestroy } from 'svelte'
    import { goto } from '@sapper/app'
    import Header from 'components/Header.svelte'
    import Notifications from 'components/Nav/Notifications.svelte'
    import Spinner from 'components/Icons/Spinner.svelte'
    import Hide from 'components/Icons/Hide.svelte'
    import Avatar from 'components/User/Avatar.svelte'
    import Name from 'components/User/Name.svelte'
    import { del } from 'lib/fetch'
    import { notifications } from 'lib/notifications'
    import { awaitingAPI } from 'store'

    let read = []

    onDestroy(() => {
        if (read.length === 0) return

        del('api/notifications/answers', { ids: read })
    })

    const markAsRead = id => {
        read = [...read, id]
    }

    const handleClick = id => {
        markAsRead(id)
        goto(`/post/${id}`)
    }

    const readAll = () => {
        read = $notifications.answers.map(n => n.id)
    }
</script>

<Header withBorder={false}>
    Notifications
    <slot slot="nav">
        <Notifications segment="reponses" />
    </slot>
</Header>

<section>
    {#if !$awaitingAPI && $notifications.answers}
        <button on:click={readAll} class="readAll">
            <Hide small />
            Tout marquer comme lu
        </button>
        {#each $notifications.answers as answer (answer.id)}
            <article class:read={read.includes(answer.id)}>
                <a
                    href="/post/{answer.id}"
                    on:click|preventDefault={handleClick(answer.id)}>
                    <header>
                        <Avatar
                            src={answer.author.avatar}
                            name={answer.author.name}
                            small={true}
                        />
                        <Name>
                            {answer.author.name}
                            <span slot="username"
                                >@{answer.author.username}</span
                            >
                        </Name>
                        <span> il y a <time>{answer.created_at}</time> </span>
                    </header>
                    <p class="content">{answer.content}</p>
                </a>
                {#if !read.includes(answer.id)}
                    <div class="markAsRead">
                        <button on:click={markAsRead(answer.id)}>
                            <Hide />
                        </button>
                    </div>
                {/if}
            </article>
        {:else}
            <div class="no-content">
                Tu n'as aucune notification pour le moment.<br />
                Poste un message pour inciter les autres à te répondre !
            </div>
        {/each}
    {:else}
        <div class="no-content">
            <Spinner />
        </div>
    {/if}
</section>

<style lang="postcss">
    section {
        @apply bg-blueGray-50 pt-2;

        .readAll {
            @apply flex items-center gap-x-1 ml-auto mr-4 mb-2 text-teal-500;
        }

        article {
            @apply p-4 flex gap-x-4 bg-white border-t;

            &.read {
                @apply cursor-not-allowed opacity-30;
            }

            &:last-of-type {
                @apply border-b;
            }

            a {
                @apply min-w-0;

                header {
                    @apply flex gap-x-2 min-w-0 mb-1;

                    span {
                        @apply flex-shrink-0 text-teal-600;
                    }
                }

                .content {
                    @apply flex-initial truncate;
                }
            }

            .markAsRead {
                @apply flex-1 flex place-items-center;

                button {
                    @apply text-sm text-teal-500;
                }
            }
        }

        .no-content {
            @apply flex items-center justify-center text-center p-4 text-blueGray-500;
        }
    }
</style>
